tabForwardSim <- function() {
  dir(varSave) %>% 
    map_df(
      ~le(.), 
      .id = 'trial'
    ) %>% 
    ml(
      id.vars = c('trial', 'convergence', 'num.paths'),
      measure.vars = c('error', 'time')
    ) %>% 
    dc(trial + num.paths ~ convergence + variable, value.var = 'value') %>% 
    bootSample(boot.num = 1000) %>% 
    mt(
      ratio_error = regular.convergence_error / strong.convergence_error,
      ratio_time = regular.convergence_time / strong.convergence_time
    ) %>% 
    gb(samp, num.paths) %>% 
    sm(
      `Error Ratio` = exp(mean(log(ratio_error))),
      `Time Ratio` = exp(mean(log(ratio_time)))
    ) %>% 
    ug %>% 
    mt(num.paths = prettyNum(num.paths, big.mark = ',')) %>% 
    mt(num.paths = as.factor(num.paths)) %>% 
    mt(num.paths = fct_relevel(num.paths, '100', '1,000')) %>% 
    ml(c('samp', 'num.paths')) %>% 
    make.table(
      variable ~ num.paths, 
      out.file = p0(data.out, 'out.tex')
    )
}