source('modules/Classes/Estimator.R')

runEstimators <- function(){
  df(
    num.paths = 
      (10^(2:4)) %>% 
      rep(100)
  ) %>% 
    rownames_to_column %>% 
    d_(~rowname, function(s){
      est <-
        Estimator$new() %T>% {
          .$initializeEstimator()
        }
      
      est$sim.horizons %>% 
        map_df(function(num.periods) {
          system.time(
            est$estimateModel(
              num.paths = s$num.paths,
              num.periods = num.periods
            )
          ) %>% {
            df(
              error = sqrt(sum((est$theta.estimate - est$theta)^2)),
              time = .[['elapsed']],
              num.paths = s$num.paths,
              num.periods = num.periods
            )
          }
        }, .id = 'convergence') %>% 
        se(p0(s$rowname, '.R'))
    }, .parallel = TRUE)
}

