###Header
my.library <- '/Users/robertlbray/Dropbox/code/R/library'
funs.loc <- '../funs/'

.libPaths(my.library)
library('tidyverse')

c('reshape2', 'stringr', 'magrittr', 'xtable', 'Matrix', 'BB') %>%
  walk(~library(., character.only=TRUE))

dir(funs.loc) %>% 
  walk(~source(paste(funs.loc, ., sep="")))

dir('./modules', recursive = TRUE) %>% 
  walk(~source(paste('./modules/', ., sep="")))

varSave <- './outputs/'

###Run estimator
c(0.9, 0.99, 0.999, 0.9999, 1) %>% 
  map(function(beta){
    dp <<- 
      DPEngine$new() %T>% {
        .$initialize_DP(beta = beta)
      }
    
    out <- list(beta = beta)
    
    if(beta < 1) {
      dp$solve_pakes(
        relative = FALSE,
        porteus = FALSE
      )
      out$bellman.traditional <- dp$bellman.count
    } else {
      out$bellman.traditional <- Inf
    }
    
    dp$reset_system()
    dp$solve_pakes(
      relative = TRUE,
      porteus = FALSE
    )
    out$bellman.relative <- dp$bellman.count
    
    dp$reset_system()
    dp$solve_pakes(
      relative = TRUE,
      porteus = TRUE
    )
    out$bellman.porteus <- dp$bellman.count
    
    out
  }) %>% 
  se('pakes.rds')

###Tabulate output

tab_pakes()

