Transition <- 
  setRefClass(
    'Transition',
    fields = list(
      theta = 'list',
      tran = 'data.frame'
    ),
    methods = list(
      calc_tran = function(policy){
        tran <<- 
          expand.grid(
            omega.i = seq(theta$M),
            omega.j = seq(theta$M),
            omega.i. = seq(theta$M)
          ) %>% 
          ij(policy) %>% 
          mt(
            prob.i = 0,
            prob.i = 
              if_else(
                omega.i. == omega.i + 1,
                (1-theta$delta) * theta$alpha * x.i / (1 + theta$alpha * x.i),
                prob.i
              ),
            prob.i = 
              if_else(
                omega.i. == omega.i - 1,
                theta$delta / (1 + theta$alpha * x.i),
                prob.i
              ),
            prob.i = 
              if_else(
                (omega.i. == omega.i) & (omega.i == 1),
                (1+theta$delta * theta$alpha * x.i) / (1 + theta$alpha * x.i),
                prob.i
              ),
            prob.i = 
              if_else(
                (omega.i. == omega.i) & (omega.i == theta$M),
                (1-theta$delta + theta$alpha * x.i) / (1 + theta$alpha * x.i),
                prob.i
              ),
            prob.i = 
              if_else(
                (omega.i. == omega.i) & (!(omega.i %in% c(1, theta$M))),
                (1-theta$delta + theta$delta * theta$alpha * x.i) / (1 + theta$alpha * x.i),
                prob.i
              )
          ) %>% 
          sl(-x.i)
      }
  )
)