tab_pakes <- function() {
  library('forcats')
  library('plyr')
  
  le('pakes.rds') %>% 
    map_df(~ad(.)) %>% 
    ml('beta') %>% 
    mt(
      variable = fct_relevel(
        variable, 'bellman.traditional', 'bellman.relative'
      )
    ) %>% 
    mt(
      variable = fct_recode(
        variable, 
        `Value Iteration` = 'bellman.traditional',
        `Relative Value Iteration` = 'bellman.relative',
        `Accelerated Relative Value Iteration` = 'bellman.porteus' 
      ),
      value = ifelse(
        value == Inf,
        '$ \\infty $',
        formatC(value, format="d", big.mark=",")
      )
    ) %>% 
    make.table(
      variable ~ beta ,
      table.type = 'Summary',
      out.file = p0(varSave, 'pakes_tab.txt'),
      align.cols = 'lccccc'
    ) 
}